# 需求

需求收集与整理，可以多画画思维导图，因为部分需求之间是存在关联关系的，要将需求的关系、层级理顺。

## 什么样的需求该忽略

没有大量数据证明切实符合用户实际需要的。

### 1.拍拍脑袋得来的想法，往往是没用的

硬币皆有两面，要用批判的眼光去审视产品经理的点子。

当下这个阶段，人人都是产品经理，各种野路子如雨后春笋，导致好的产品经理凤毛麟角。

当产品经理拍拍脑袋提出了一个想法，该做的事情是，让他先去做一个详细的市场调研，给出报告和可行性分析。

举一个我见过的例子：

很早之前我们团队接到一个任务，设计一款新的网关产品。产品经理的想法是将受众用户群体定位在青年人。这样就跟小米——“为发烧而生”不谋而合，直面迎来了一个还算比较强大的竞争对手。

当时我提出了一个针对老龄化的设想，主题是傻瓜化、真智能，让中老年人都能轻松上手的产品。直到2016年，才出了“爱国者聚路由”这样稍微有点神似的产品。

### 2.用户反馈的信息，不应该直接纳入需求

根据二八原则，将80%精力放在20%最有价值产出的事情上。

用户的需求是需求，但不一定是大众需求。所以如果是一个只有三五十活跃用户的反馈组里，得到的反馈信息仅能作为参考。

举个例子：

假设有这样一个问题：智能门锁通过手机解锁是否需要输入密码。在用户群里，有一些用户反馈说手机App上开锁还要打密码很麻烦，不如去掉这一步的密码校验，得到了一批人的支持。

但这样的需求不可取。实际的需求依然需要大量的数据去支撑。一方面，方便和安全，都需要考虑。另一方面，如果大量的用户反馈觉得这样比较麻烦，最佳实践应该是，保留App上的密码解锁功能，但可以设置开启或关闭，默认开启，由用户去控制，为了方便可以将其关闭，但由于这种用户自发行为导致的安全隐患，就得交由用户自行承担。

### 3.扭改用户习惯的需求，一律不考虑

用户行为引导应该是个缓慢而循序渐进的过程。在做技术架构的时候可以稍微激进一点，采用一些新架构新技术去尝试，能提高系统性能；但是在做产品架构的时候，不可冒进。

举例说明：

原有用户账号体系中，不支持手机号注册、登录。在添加这项新功能后，应该是引导用户绑定手机，允许原有方式登录，并增加新的方式登录。尊重原有用户使用用户名的习惯，逐步培养绑定手机号的安全行为，但不能强制用户将登录习惯也改为用手机号进行登录。

因为假设我的用户名为 `wzl` 或者 `willin` 都会比手机号（11位）输入更方便，所以这样的引导并不能帮助用户得到什么益处。不可取。

## 什么样的需求该重视

### 1.从运维系统中根据数据结果分析得出的结论

完善运维系统，采集更多需要的信息。根据信息分析得出的可靠结论，才是最重要的需求点。

这里就不举例展开了，一方面数据都是比较私密的，另外一方面，数据所展示出来的问题都是比较明显的。

### 2.重视有洞见者的每一句话

什么样的人输出什么样的创意。没有偏见，客观陈述。狗嘴里吐不出象牙，所以不要指望肤浅的人给出多么好的意见。而能给出好创意的人，能够源源不断地输出好的创意。

设计，主要来自于思想和经验。

思想这个东西，虽然有后天弥补的空间，但基本都是与生俱来的，可视为先天优势。而经验，则需要知识和实践相结合，可视为后天富足。只有两者都满足，才能成为一个好的设计者。很苛刻，但这是事实。
